"""
PySide stub files generated by **IceSpringPySideStubs**

Home: https://baijifeilong.github.io/2022/01/06/ice-spring-pyside-stubs/index.html

Github: https://github.com/baijifeilong/IceSpringPySideStubs

PyPI(PySide2): https://pypi.org/project/IceSpringPySideStubs-PySide2

PyPI(PySide6): https://pypi.org/project/IceSpringPySideStubs-PySide6

PyPI(PyQt5): https://pypi.org/project/IceSpringPySideStubs-PyQt5

PyPI(PyQt6): https://pypi.org/project/IceSpringPySideStubs-PyQt6

Generated by BaiJiFeiLong@gmail.com

License: MIT
"""
import enum
import typing
from PyQt6 import QtGui
from PyQt6 import QtCore
from PyQt6.QtWidgets import *
import enum


class QStyleOptionHeader(QStyleOption):
    """
    https://doc.qt.io/qt-6/qstyleoptionheader.html

    **Detailed Description**

    QStyleOptionHeader contains all the information that **QStyle**  functions
    need to draw the item views' header pane, header sort arrow, and header
    label.

    For performance reasons, there are few member functions and the access to
    the member variables is direct (i.e., using the `.` or `->` operator). This
    makes the structures straightforward to use and emphasizes that these are
    simply parameters used by the style functions.

    For an example demonstrating how style options can be used, see the
    **Styles**  example.

    **See also** **QStyleOption** .
    """

    class SortIndicator(enum.Enum):
        None_: QStyleOptionHeader = ...
        SortUp: QStyleOptionHeader = ...
        SortDown: QStyleOptionHeader = ...

    class SelectedPosition(enum.Enum):
        NotAdjacent: QStyleOptionHeader = ...
        NextIsSelected: QStyleOptionHeader = ...
        PreviousIsSelected: QStyleOptionHeader = ...
        NextAndPreviousAreSelected: QStyleOptionHeader = ...

    class SectionPosition(enum.Enum):
        Beginning: QStyleOptionHeader = ...
        Middle: QStyleOptionHeader = ...
        End: QStyleOptionHeader = ...
        OnlyOneSection: QStyleOptionHeader = ...

    class StyleOptionVersion(enum.Enum):
        Version: QStyleOptionHeader = ...

    class StyleOptionType(enum.Enum):
        Type: QStyleOptionHeader = ...

    icon: QtGui = ...
    iconAlignment: QtCore = ...
    orientation: QtCore = ...
    position = ...
    section: int = ...
    selectedPosition = ...
    sortIndicator = ...
    text: str = ...
    textAlignment: QtCore = ...

    @typing.overload
    def __init__(self) -> None:
        """
        https://doc.qt.io/qt-6/qstyleoptionheader.html#QStyleOptionHeader

        **QStyleOptionHeader::QStyleOptionHeader()**

        Constructs a QStyleOptionHeader, initializing the members variables to
        their default values.
        """
        ...

    @typing.overload
    def __init__(self, other: "QStyleOptionHeader") -> None:
        """
        https://doc.qt.io/qt-6/qstyleoptionheader.html#QStyleOptionHeader-1

        **QStyleOptionHeader::QStyleOptionHeader(const QStyleOptionHeader &
        other )**

        Constructs a copy of the **other** style option.
        """
        ...
